'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = subscribeAdapter;

var _socket = require('socket.io-client');

var _socket2 = _interopRequireDefault(_socket);

var _util = require('./util');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function subscribeAdapter() {
  var _onEvent = void 0,
      _onDisconnect = void 0;
  var origin = typeof navigator !== 'undefined' && navigator.product === 'ReactNative' ? process.env['ROOT_PATH'] : window.location.origin;
  var socket = (0, _socket2.default)(origin, {
    path: (0, _util.getRootableUrl)('/socket/'),
    transports: ['websocket']
  });

  var latePromise = (0, _util.makeLateResolvingPromise)();

  socket.on('event', function (event) {
    return _onEvent(JSON.parse(event));
  });

  socket.on('connect', function () {
    return latePromise(socket.id);
  });

  socket.on('reconnect', function () {
    latePromise = (0, _util.makeLateResolvingPromise)(socket.id);
  });

  socket.on('disconnect', function (reason) {
    latePromise = (0, _util.makeLateResolvingPromise)();
    _onDisconnect(reason);
  });

  return {
    onEvent: function onEvent(callback) {
      _onEvent = callback;
    },
    onDisconnect: function onDisconnect(callback) {
      _onDisconnect = callback;
    },
    setSubscription: function setSubscription(_ref) {
      var aggregateIds = _ref.aggregateIds,
          types = _ref.types;

      socket.emit('setSubscription', {
        ids: aggregateIds, // TODO. Fix server-side
        types: types
      });
    },
    getClientId: function getClientId() {
      var _this = this;

      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return latePromise;

              case 2:
                return _context.abrupt('return', _context.sent);

              case 3:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, _this);
      }))();
    }
  };
}